c***********************************************************
      subroutine forces_molec_non_bonded(fx,fy,fz,vp,v,w,winter)
      implicit none   
      include 'parameters.inc'      
      include 'nparticulas.inc'  
      include 'config.inc'
      include 'headlist.inc'
      include 'geom.inc'
      include 'veloc.inc'
      include 'sigmas.inc' 
      include 'epsilons.inc' 

      real fx(nmax),fy(nmax),fz(nmax),vp(nmax)
      real v,w,winter,wintra
      integer iceldx,iceldy,iceldz,iceld,iceldxnb,iceldynb,iceldznb
      integer nbcel,inb
      integer i,j
      real rxi,rxij,ryi,rzi,ryij,rzij,rij2
      real rxj,ryj,rzj
      real fxi,fxij,fyi,fyij,fzi,fzij
      real vij,wij,fij      
      real sr2,sr6
      real  sig,eps_sig,eps_sig6,eps_sig12,aa,bb,eps,sgn
      real  rcutoff2

      logical fueracaja
      integer inabor(13),jnabor(13),knabor(13)
      common /ijnabr/inabor,jnabor,knabor
      INCLUDE 'molecules.inc'
      real  sum
      INCLUDE 'coarse_grain_forces.inc'
      integer imol,jmol,index,iindex
      include 'index0_pairs.inc'

      integer im0,im1,i0,i1

c      initialize to zero
                  call links

c*************************************************
c     inicializacion de fuerzas y potencial
c*************************************************
      
                  sum=0.
      do i=1,nmax
         fx(i)=0.0d0
         fy(i)=0.0d0
         fz(i)=0.0d0
         vp(i)=0.0
      end do

      fxi=0.0d0
      fyi=0.0d0
      fzi=0.0d0
      v=0.0d0
      w=0.0d0               !total virial
      wintra=0.0d0               !intermolecular virial
      winter=0.0          !intermolecular virial

      call zero_array(npairmx,fpairx,fpairy,fpairz)

      sr2=0.0d0
      sr6=0.0d0
c*************************************************
c     bucle para todas las celdas
c*************************************************

      do 5000 iceldz=1,mz      
      do 5000 iceldy=1,my
      do 5000 iceldx=1,mx

         iceld=iceldx+mx*(iceldy-1)+(iceldz-1)*my*mx
         i=head(iceld)                           

c*************************************************
c    comienzo del bucle para todas las particulas
c    en la celda actual (iceld)
c*************************************************

 1000    if(i.gt.0) then            ! este "if" concluye al final                  

c     ** Carry R to the pbc calculation box (R is unbounded)
c     ** domain is (-0.5,0.5)*lx, etc...
            rxi=rx(i)-anint(rx(i)/lx)*lx
            ryi=ry(i)-anint(ry(i)/ly)*ly
            rzi=rz(i)-anint(rz(i)/lz)*lz
            
c ** add to fxi forces already evaluated when i was smaller and the actual i was j
            fxi=fx(i)
            fyi=fy(i)
            fzi=fz(i)
            
c     iceld -. indice de celda de calculo head&list


c*************************************************
c     bucle para todas las particulas "j",proximas
c      a "i" en la celda actual "iceld"
c*************************************************

            j=list(i)

 2000       if (j.gt.0) then


            

               rxj=rx(j)-anint(rx(j)/lx)*lx
               ryj=ry(j)-anint(ry(j)/ly)*ly
               rzj=rz(j)-anint(rz(j)/lz)*lz
               

               rxij= rxi-rxj
               ryij= ryi-ryj
               rzij= rzi-rzj
               

c     ** periodic b.c. for x y and z **
               rxij=rxij-anint(rxij/lx)*lx
               ryij=ryij-anint(ryij/ly)*ly
               rzij=rzij-anint(rzij/lz)*lz
               rij2=rxij*rxij+ryij*ryij+rzij*rzij            
               
               sig=0.5*(sigma(i)+sigma(j))
               rcutoff2=(rcut*sig)**2
               if(rij2.lt.rcutoff2) then
               
                  fij=0.
                  vij=0.
                  wij=0.0


                  eps=epsilon(i)*epsilon(j)
                  eps=sqrt(eps)
                  eps_sig6=(eps*sig)**6
                  eps_sig12=eps_sig6**2

                  AA=eps_sig12
                  BB=eps_sig6
                  sr2 = 1.0d0/rij2
                  sr6 = sr2*sr2*sr2
                  
                  vij=sr6*(AA*sr6-BB)
                  vij=vij-vcut
                  wij=sr6*(AA*sr6-0.5*BB)
                  fij=wij/rij2

                                   
                  vp(i)=0.5*vij+vp(i)
                  vp(j)=0.5*vij+vp(j)

                  v=v+vij
                  w=w+wij
                  
c----------------
                                   
                  fxij=fij*rxij
                  fyij=fij*ryij
                  fzij=fij*rzij
                  
                  fxi=fxi+fxij
                  fyi=fyi+fyij
                  fzi=fzi+fzij
                  
                  fx(j)=fx(j)-fxij
                  fy(j)=fy(j)-fyij
                  fz(j)=fz(j)-fzij
                  
c     **     fuerzas entre moleculas  --------
                  imol=(i-1)/nmon +1
                  jmol=(j-1)/nmon +1                  
                  if(jmol.ne.imol) then        !if molecules are different
                     im0=min(imol,jmol)        !name the minimum index of molecule as im0
                     im1=max(imol,jmol)        !maximum index im1
                     sgn=-1.0
                     if(im0.eq.imol) sgn=1.0
                     iindex=index0(im0)        !initial Pair_index of lowest Molecule_index
                     index= iindex + (im1-im0) ! add the rest for Pair_index of (imol,jmol)
                     fpairx(index) = fpairx(index) + fxij*sgn
                     fpairy(index) = fpairy(index) + fyij*sgn
                     fpairz(index) = fpairz(index) + fzij*sgn

                     winter= winter + wij            !intermolecular virial
                  else
                     wintra=wintra +wij
                  end if
               endif           
   
               j=list(j)


               
               go to 2000
               
            endif
            
c*************************************************
c     bucle para todas las celdas vecinas a "iceld", y
c     bucle para todas las particulas proximas
c     a la particula "i"
c*************************************************
          
          do 4000 inb=1,13
             
             iceldxnb=iceldx+inabor(inb)
             iceldynb=iceldy+jnabor(inb)
             iceldznb=iceldz+knabor(inb)
             
c     ** periodic b.c. for y and z **    
             if(iceldxnb.eq.0) iceldxnb=mx
             if(iceldxnb.eq.mx+1) iceldxnb=1          
             if(iceldynb.eq.0) iceldynb=my
             if(iceldynb.eq.my+1) iceldynb=1
             if(iceldznb.eq.0) iceldznb=mz
             if(iceldznb.eq.mz+1) iceldznb=1
             

             
c     * * * * * * * * * * * * * * * * * * * * * * * * * 
             
             nbcel= iceldxnb+mx*(iceldynb-1)+mx*my*(iceldznb-1)                       
             

             j=head(nbcel)
             
             
 3000        if(j.ne.0)then               
 

               rxj=rx(j)-anint(rx(j)/lx)*lx
               ryj=ry(j)-anint(ry(j)/ly)*ly
               rzj=rz(j)-anint(rz(j)/lz)*lz
               
               rxij= rxi-rxj
               ryij= ryi-ryj
               rzij= rzi-rzj
               
                
c     ** periodic b.c. for x y and z **
               rxij=rxij-anint(rxij/lx)*lx
               ryij=ryij-anint(ryij/ly)*ly
               rzij=rzij-anint(rzij/lz)*lz
               rij2=rxij*rxij+ryij*ryij+rzij*rzij
                
               sig=0.5*(sigma(i)+sigma(j))
               rcutoff2=(rcut*sig)**2
               if(rij2.lt.rcutoff2) then
                  
                  fij=0.
                  vij=0.
                  wij=0.0
                  
                  eps=epsilon(i)*epsilon(j)
                  eps=sqrt(eps)
                  eps_sig6=(eps*sig)**6
                  eps_sig12=eps_sig6**2
                  
                  AA=eps_sig12
                  BB=eps_sig6
                  sr2 = 1.0d0/rij2
                  sr6 = sr2*sr2*sr2
                  
                  vij=sr6*(AA*sr6-BB)
                  vij=vij-vcut
                  wij=sr6*(AA*sr6-0.5*BB)
                  fij=wij/rij2
                   
                  v=v+vij
                  
                  vp(i)=0.5*vij+vp(i)
                  vp(j)=0.5*vij+vp(j)
                  
                  w=w+wij
                  
c----------------
                  fxij=fij*rxij
                  fyij=fij*ryij
                  fzij=fij*rzij
                  
                  fxi=fxi+fxij
                  fyi=fyi+fyij
                  fzi=fzi+fzij
                  
                  fx(j)=fx(j)-fxij
                  fy(j)=fy(j)-fyij
                  fz(j)=fz(j)-fzij
                  
c     **     fuerzas entre moleculas  --------               
                  imol=(i-1)/nmon +1
                  jmol=(j-1)/nmon +1
                  if(jmol.ne.imol) then
                     im0=min(imol,jmol)
                     im1=max(imol,jmol)
                     sgn=-1.0
                     if(im0.eq.imol) sgn=1.0
                     iindex=index0(im0)
                     index= iindex + (im1-im0)
                     fpairx(index) = fpairx(index) + fxij*sgn
                     fpairy(index) = fpairy(index) + fyij*sgn
                     fpairz(index) = fpairz(index) + fzij*sgn
                     winter= winter + wij            !intermolecular virial
                  else
                     wintra=wintra +wij
                  end if

               endif
                
                j=list(j)

                
                go to 3000
                
             end if
             
 4000     continue
          
          fx(i)=fxi
          fy(i)=fyi
          fz(i)=fzi
   
c*********************************************************
c     siguiente particula de la celda actual "iceld"
c*********************************************************
          i=list(i)
          
          go to 1000
          
       end if
       
 5000 continue
      
c******************************************************
c     incorporacion de los factores de energia 
c******************************************************
      v=4.0d0*v
      w=48.0d0*w
      winter=48.0*winter
      wintra=48.0*wintra
c     **check **ok***   write(*,*) w,winter,wintra,winter+wintra
      do i=1,np   
         fx(i)=48.0*fx(i)
         fy(i)=48.0*fy(i) 
         fz(i)=48.0*fz(i) 
         vp(i)=4.0*vp(i)
      enddo
      
c     *** NOTE: THE factor 48 to molecule forces is multiplied in center_of_mass_.f


c         eifreq=eifreq+(fx(i)*fx(i)+fy(i)*fy(i)+fz(i)*fz(i))
c            eifreq=eifreq/dble(np_md)/3.0

      return
      end


