      program montecarlo
      implicit none
      include 'nparticles.inc'
      include 'init.inc'
      real amp
      integer i,step
      logical accept
      real rold(3),rnew(3),enew,eold,dener
      real fac,rnd

      call init(amp)
      call control(0,accept,amp)
      call radial_distribution(0)

      do step=1,nstep         

         call mc_move

         if(mod(step,nsamp).eq.0) then
            call radial_distribution(1)
         end if
         
         if(mod(step,nsave).eq.0) then
            call save
            call radial_distribution(2)
         end if

      end do
      end

      call links(x,y,z)
      subroutine mc_move(imov)
      implicit none

      REAL x(npmax),y(npmax),z(npmax)
      logical ovlp

      ovlp=.false.

      call celda(imov,icelx,icely,icelz,iceld)      
      call get_posic(imov,rimov)               
      
      i=head(iceld)       !head particle of iceld of imov
   
      if(i.ne.imov) then
         call get_posic(i,ri)
         call overlap(rimov,ri,ovlp)
         if(ovlp) return
      end if

c    comienzo del bucle para todas las particulas en la celda actua (iceld)
 1000 if(i.gt.0) then           ! este "if" concluye al final          
         j=list(i)              !bucle para todas las particulas "j",proximas
 2000    if (j.gt.0) then
            
            if(j.ne.imov) then
               call get_posic(j,rj)
               call overlap(rimov,rj,ovlp)
               if(ovlp) return
               j=list(j)
            end if
            go to 2000
         end if
 1000    continue

c     ++++++++++

         do 4000 inb=1,13
            call icelnb(inb,icelx,icely,icelz,nbcel)
            
            j=head(nbcel)
 3000       if(j.ne.0)then         
c---- 
               if(j.ne.imov) then
                  call get_posic(j,rj)
                  call overlap(rimov,rj,ovlp)
                  if(ovlp) return
               end if
c---- 
               j=list(j)
               go to 3000
            end if
 4000    continue
         
c     end of loop over all particles near i=imov
         
         return
         end



      subroutine icelnb(inb,icelx,icely,icelz,nbcel)
      implicit none
      
      icelxnb=icelx+inabor(inb)
      icelynb=icely+jnabor(inb)
      icelznb=icelz+knabor(inb)
c     ** periodic b.c. for y and z **    
      if(icelxnb.eq.0) icelxnb=mx
      if(icelxnb.eq.mx+1) icelxnb=1          
      if(icelynb.eq.0) icelynb=my
      if(icelynb.eq.my+1) icelynb=1
      if(icelznb.eq.0) icelznb=mz
      if(icelznb.eq.mz+1) icelznb=1
      nbcel= icelxnb+mx*(icelynb-1)+mx*my*(icelznb-1)   
      return      
      end
